SystemOrganization addCategory: #'Either-Tests'!
SystemOrganization addCategory: #Either!

Object subclass: #Either
	instanceVariableNames: 'value'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either'!

!Either class methodsFor: 'monad' stamp: 'fbs 7/6/2011 12:20'!
return
	^ [:x | Right value: x].! !

!Either class methodsFor: 'monad' stamp: 'fbs 7/6/2011 12:19'!
return: anObject
	^ self return value: anObject! !

!Either class methodsFor: 'instance creation' stamp: 'fbs 7/1/2011 13:51'!
value: anObject
	^ self new value: anObject! !

!Either methodsFor: 'testing' stamp: 'fbs 7/1/2011 13:57'!
isRight
	self subclassResponsibility! !

!Either methodsFor: 'accessing' stamp: 'fbs 7/1/2011 13:50'!
value
	^ value! !

!Either methodsFor: 'private' stamp: 'fbs 7/1/2011 13:51'!
value: anObject
	value := anObject.! !

Either subclass: #Left
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either'!

!Left methodsFor: 'comparing' stamp: 'fbs 7/6/2011 17:31'!
= anObject
	^ anObject isRight not and: [anObject value = value].! !

!Left methodsFor: 'monad' stamp: 'fbs 7/1/2011 14:04'!
>>= anEitherReturningUnaryBlock
	^ self.! !

!Left methodsFor: 'testing' stamp: 'fbs 7/1/2011 13:55'!
isRight
	^ false.! !

!Left methodsFor: 'printing' stamp: 'fbs 7/6/2011 17:25'!
printOn: aStream
	aStream nextPutAll: 'Left '.
	value printOn: aStream.! !

Either subclass: #Right
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either'!

!Right methodsFor: 'comparing' stamp: 'fbs 7/6/2011 17:28'!
= anObject
	^ anObject isRight and: [anObject value = value].! !

!Right methodsFor: 'monad' stamp: 'fbs 7/1/2011 14:07'!
>>= anEitherReturningUnaryBlock
	^ anEitherReturningUnaryBlock value: value! !

!Right methodsFor: 'testing' stamp: 'fbs 7/1/2011 13:57'!
isRight
	^ true.! !

!Right methodsFor: 'printing' stamp: 'fbs 7/6/2011 17:25'!
printOn: aStream
	aStream nextPutAll: 'Right '.
	value printOn: aStream.! !

TestCase subclass: #LeftTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either-Tests'!

!LeftTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:27'!
testLeftEqualsItself
	| left |
	left := Left value: 1.
	self assert: left = left.! !

!LeftTest methodsFor: 'testing - testing' stamp: 'fbs 7/1/2011 14:01'!
testLeftIsNotRight
	self deny: (Left value: 1) isRight! !

!LeftTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:29'!
testLeftNotEqualToRight
	self deny: (Left value: 1) = (Right value: 1).! !

!LeftTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:27'!
testLeftWithEqualValuesEqual
	self assert: (Left value: 1) = (Left value: 1).! !

!LeftTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:28'!
testLeftWithUnequalValuesNotEqual
	self deny: (Left value: 1) = (Left value: 2).! !

!LeftTest methodsFor: 'testing - printing' stamp: 'fbs 7/6/2011 12:23'!
testPrintStringPrintsUsefully
	self assert: (Left value: 1) printString = 'Left 1'.
	self assert: (Left value: 'wrong') printString = 'Left ''wrong'''.! !

TestCase subclass: #RightTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either-Tests'!

!RightTest methodsFor: 'testing - printing' stamp: 'fbs 7/6/2011 12:23'!
testPrintStringPrintsUsefully
	self assert: (Right value: 1) printString = 'Right 1'.
	self assert: (Right value: 'wrong') printString = 'Right ''wrong'''.! !

!RightTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:30'!
testRightEqualsItself
	| right |
	right := Left value: 1.
	self assert: right = right.! !

!RightTest methodsFor: 'testing - testing' stamp: 'fbs 7/1/2011 14:00'!
testRightIsRight
	self assert: (Right value: 1) isRight.! !

!RightTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:29'!
testRightNotEqualToLeft
	self deny: (Right value: 1) = (Left value: 1).! !

!RightTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:30'!
testRightWithEqualValuesEqual
	self assert: (Right value: 1) = (Right value: 1).! !

!RightTest methodsFor: 'testing - comparing' stamp: 'fbs 7/6/2011 17:30'!
testRightWithUnequalValuesNotEqual
	self deny: (Right value: 1) = (Right value: 2).! !

MonadTestCase subclass: #EitherTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Either-Tests'!

!EitherTest methodsFor: 'data' stamp: 'fbs 7/6/2011 12:18'!
f
	^ [:x | Right value: (x + 1)].! !

!EitherTest methodsFor: 'data' stamp: 'fbs 7/6/2011 12:18'!
g
	^ [:x | Left value: x].! !

!EitherTest methodsFor: 'data' stamp: 'fbs 7/6/2011 12:18'!
monad
	^ Either.! !

!EitherTest methodsFor: 'data' stamp: 'fbs 7/6/2011 12:18'!
sampleBlock
	^ [:x | Right value: x]! !

!EitherTest methodsFor: 'data' stamp: 'fbs 7/6/2011 12:17'!
sampleValues
	^ #(1 '2' #(3))! !

!EitherTest methodsFor: 'testing - monad' stamp: 'fbs 7/1/2011 14:08'!
testBindToLeftReturnsLeft
	self deny: ((Left value: 1) >>= [:x | Right value: x]) isRight.
	self deny: ((Left value: 1) >>= [:x | Left value: x]) isRight.! !

!EitherTest methodsFor: 'testing - monad' stamp: 'fbs 7/1/2011 14:08'!
testBindToRightReturnsDeeperValue
	self deny: ((Right value: 1) >>= [:x | Left value: x]) isRight.
	
	self assert: ((Right value: 1) >>= [:x | Right value: 2]) isRight.
	self assert: ((Right value: 1) >>= [:x | Right value: 2]) value = 2.! !

!EitherTest methodsFor: 'testing - monad' stamp: 'fbs 7/1/2011 13:57'!
testReturnReturnsaRight
	self assert: (Either return: 1) isRight.! !
